Subject: bug#46033: up arrow in query replace should not step into the prompt

From: Juri Linkov <[email-masked]>
Date: Sat, 23 Jan 2021 20:34:34 +0200

>> This patch avoids moving point to the prompt on the rightful
>> assumption that most of the time the users would not want to edit
>> read-only text:
>
> This breaks the history retrieval feature with up arrow.
>
> With the current implementation up arrow takes you into the prompt, but if
> you are in the top line of the prompt and press up arrow again then up
> arrow retrieves history.
>
> In the case I described going into the prompt is useless, so up arrow
> should retrieve history immediately, without having to go to the top
> line of the prompt first.

This is exactly what the patch does.  Have you really tried it?